package jrummikub.util;

import java.util.HashSet;

/**
 * Simple single parameter event generator
 * 
 * @param <T1>
 *          type of the first event parameter
 * @param <T2>
 *          type of the second event parameter
 */
public class Event2<T1, T2> implements IEvent2<T1, T2> {
	private HashSet<IListener2<T1, T2>> listeners = new HashSet<IListener2<T1, T2>>();

	@Override
	public Connection add(final IListener2<T1, T2> listener) {
		listeners.add(listener);
		return new Connection() {

			@Override
			public void remove() {
				Event2.this.remove(listener);
			}
		};
	}

	@Override
	public void remove(IListener2<T1, T2> listener) {
		listeners.remove(listener);
	}

	/**
	 * Generate a single event
	 * 
	 * @param value1
	 *          the first event parameter
	 * @param value2
	 *          the second event parameter
	 */
	public void emit(T1 value1, T2 value2) {
		for (IListener2<T1, T2> listener : listeners) {
			listener.handle(value1, value2);
		}
	}
}
